﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Optimization;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Encodings.ParameterConfigurationEncoding {
  [StorableClass]
  public class AlgorithmProblemItem : ParameterizedNamedItem {
    #region Parameter Properties
    public IValueParameter<IAlgorithm> AlgorithmParameter {
      get { return (ValueParameter<IAlgorithm>)Parameters["Algorithm"]; }
    }
    public IValueParameter<IProblem> ProblemParameter {
      get { return (ValueParameter<IProblem>)Parameters["Problem"]; }
    }
    #endregion

    #region Constructors and Cloning
    [StorableConstructor]
    protected AlgorithmProblemItem(bool deserializing) : base(deserializing) { }
    protected AlgorithmProblemItem(AlgorithmProblemItem original, Cloner cloner) : base(original, cloner) { }
    public AlgorithmProblemItem()
      : base() {
      this.Parameters.Add(new ValueParameter<IAlgorithm>("Algorithm"));
      this.Parameters.Add(new ValueParameter<IProblem>("Problem"));
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new AlgorithmProblemItem(this, cloner);
    }
    #endregion
  }
}
